<template src="./editAttributesComponent.htm"></template>

<script>

    import Vue from 'vue';
    import VueBootstrapTypeahead from 'vue-bootstrap-typeahead';
    import VueTagsInput from '@johmun/vue-tags-input';
    import combos from 'combos';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    export default {

        mounted() {

            this.setSelectedWarehouse();

            eventBus.$on('entity-loaded', () => this.parseProductVariantsStoreObject());
        },

        data() {

            return {

                productAttributes: [],

                oldVariants: [],

                variants: [],

                selectedWarehouse: null
            }
        },

        mixins: [ ValidationErrorsMixin ],

        components: { VueBootstrapTypeahead, VueTagsInput },

        methods: {

            /**
             * Parse old variants.
             */
            parseProductVariantsStoreObject() {

                let product = this.$store.state.product;

                this.parseOldAttributes(product.attributes);

                this.parseOldVariants(product.variants);
            },


            /**
             * Helper method for parsing store product attributes
             *
             * @param attributes
             */
            parseOldAttributes(attributes) {

                attributes.forEach( (el) => {

                    this.productAttributes.push({

                        name: el.name,
                        lastInsertedTag: '',
                        values: [],
                        oldValues: el.values.map( (el) => { return { text: el.value, tiClasses: ['avoid-item'] }})
                    })
                });
            },


            /**
             * Helper method for parsing store product variants
             *
             * @param variants
             */
            parseOldVariants(variants) {

                variants.forEach( (variant) => {

                    const variantObj = {

                        id: variant.id,
                        'attributes-values': {},
                        price: variant.price,
                        sku: variant.sku,
                        warehouses: []
                    };

                    variant.product_attribute_values.forEach( (attrValue) => {

                        variantObj['attributes-values'][attrValue.attribute_value.product_attribute.name] = attrValue.attribute_value.value;
                    });

                    this.warehouses.forEach( (warehouse) => {

                        let inventory =  variant.warehouse_inventories.find( (inventory) => inventory.warehouse_id == warehouse.id);

                        variantObj.warehouses.push({

                            id: warehouse.id,
                            quantity: inventory ? inventory.quantity : 0
                        })
                    });

                    this.oldVariants.push(variantObj);
                });
            },


            /**
             * Set selected warehouse (first from array as default).
             */
            setSelectedWarehouse() {

                this.selectedWarehouse = this.warehouses.length > 0 ? this.warehouses[0] : null;
            },


            /**
             * Manually change autocomplete component inputValue attributes since reactivity is failing (value is ok)
             */
            updateAutocompleteInputValues() {

                this.$refs.attributesAutocomplete.forEach( (el, i) => el.inputValue = this.productAttributes[i].name);
            },


            /**
             * Create all variants combinations from given attributes.
             *
             * @param productAttributes
             */
            createVariants(productAttributes) {

                this.variants       = [];
                const comboObject   = {};

                //Combine old and new values in order for all combinations to make.
                productAttributes = productAttributes.map( (el) => {

                    return {

                        name: el.name,
                        values: el.oldValues.concat(el.values)
                    }
                });

                if (productAttributes.length > 0) {

                    /**
                     * Get only completed attributes from list.
                     */
                    let filteredAttributes = productAttributes.filter( (el) => el.name != '' && el.values.length > 0);

                    if (filteredAttributes.length > 0) {

                        /**
                         * Map attribute name to its values.
                         */
                        filteredAttributes.forEach( (el) => comboObject[el.name] = el.values.map( (value) => value.text));


                        /**
                         * Fill variants with all possible combinations of attributes and values.
                         */
                        combos(comboObject).forEach( (combo) => this.checkIfNewCombination(combo));
                    }
                }
            },


            /**
             * Function to prevent coping combinations after adding new values
             * and remove their initial parsed values.
             *
             * @param combo
             */
            checkIfNewCombination(combo) {

                ! this.oldVariants.map( (el) => el['attributes-values']).find( (el) => _.isEqual(el, combo)) ? this.pushVariantObject(combo) : null;
            },


            /**
             * Create and push object to variants array with given combination.
             **/
            pushVariantObject(combination) {

                this.variants.push({

                    "attributes-values": combination,

                    sku: '',

                    price: 0,

                    warehouses: this.createWarehousesArray()
                });
            } ,


            /**
             * Create default warehouses value for variants in order to pass by value not references.
             */
            createWarehousesArray() {

                return this.warehouses.map( (el) => {

                    return {

                        id: el.id,
                        quantity: 0
                    }
                });
            },


            /**
             * Custom method to determine if tag is duplicate.
             */
            isDuplicate(tags, tag, index) {

                if (! this.productAttributes[index]) {

                    return false;
                }

                return tags.map((el) => el.text).includes(tag.text) === true ||
                    this.productAttributes[index].oldValues.map((el) => el.text).includes(tag.text) === true;
            }
        },

        computed: {

            /**
             * Return all warehouses from store.
            */
            warehouses() {

                return this.$store.state.warehouses;
            },


            /**
             * Get index for new variants.
             */
            getVariantIndex(index) {

                return (index) => {

                    return this.oldVariants.length + index;
                }
            }
        },

        watch: {

            /**
             * Create variants on attributes-values changes.
             **/
            productAttributes: {

                handler(newProductAttributes) {

                    this.createVariants(newProductAttributes);
                },

                deep: true
            },


            /**
             * Update vuex store with latest variants.
             *
             * @param newVariants
             */
            variants(newVariants) {

                this.$store.dispatch('setProductVariants', this.oldVariants.concat(newVariants));
            },


            /**
             * Update vuex store with latest variants.
             *
             * @param newOldVariants
             */
            oldVariants(newOldVariants) {

                this.$store.dispatch('setProductVariants', newOldVariants.concat(this.variants));
            },


            /**
             * Set default warehouse in table.
             */
            warehouses() {

                this.setSelectedWarehouse();
            }
        }
    }

</script>